<?php
/*
	Copyright(c) 2011 Shift Tech Inc. All Rights Reserved.
 	http://www.shift-tech.jp/
*/

require_once (dirname(__FILE__).'/../../../lib/common/unitCommon.php');
require_once (dirname(__FILE__).'/../../../lib/common/imgmngrDB.php');

class extTtlImgImgTxt extends unitCommon
{
	//------ ユニット毎に必ず設定しなくてはならない変数 -------//
	var $_table = "extunit_extttlimgimgtxt"; 		//公開用テーブル名
	var $_tmptable = "extunit_extttlimgimgtxt_tmp";	//下書き用テーブル名
	var $_unit_dir = "extTtlImgImgTxt";
	var $columns = array(
					array("column"=>"pageu_code","conv"=>"n","tags"=>false),	//ユニット個別ID
					array("column"=>"title_image","conv"=>"Kva","tags"=>false),	//テキスト
					array("column"=>"title_image_sp","conv"=>"Kva","tags"=>false),	//テキスト
					array("column"=>"title_image_alt","conv"=>"Kva","tags"=>false),	//テキスト
					array("column"=>"image","conv"=>"Kva","tags"=>false),	//テキスト
					array("column"=>"image_sp","conv"=>"Kva","tags"=>false),	//テキスト
					array("column"=>"image_alt","conv"=>"Kva","tags"=>false),	//テキスト
					array("column"=>"image_cap","conv"=>"Kva","tags"=>false),	//テキスト
					array("column"=>"title","conv"=>"Kva","tags"=>false),	//テキスト
					array("column"=>"note","conv"=>"Kva","tags"=>true),	//テキスト
					array("column"=>"link_text","conv"=>"Kva","tags"=>false),	//テキスト
					array("column"=>"link_target","conv"=>"n","tags"=>false),	//テキスト
					array("column"=>"link_url","conv"=>"Kva","tags"=>false),	//テキスト
					array("column"=>"bg_color","conv"=>"n","tags"=>false),		//背景色
					array("column"=>"bdr_type","conv"=>"n","tags"=>false),		//枠線
					array("column"=>"btm_padding","conv"=>"n","tags"=>false),	//下方スペース
					array("column"=>"bg_color_sp","conv"=>"n","tags"=>false),		//背景色
					array("column"=>"bdr_type_sp","conv"=>"n","tags"=>false),		//枠線
					array("column"=>"btm_padding_sp","conv"=>"n","tags"=>false),	//下方スペース
					array("column"=>"use_sp_flg","conv"=>"n","tags"=>false)		//スマホ表示
					);

	//▼変数宣言///////////////////
	var $_data;

	//▲変数宣言///////////////////

	function extTtlImgImgTxt()
	{
		$this->__construct();
	}

	function __construct()
	{
		unitCommon::__construct();
	}
	//-----------------

	//出力データセット処理（必須）
	function setDisplayData() {
		$this->_data = $this->getDetail();

		//▼データ操作  ////////
		if($this->_data!=null){
			if(defined("SP_FLG") && SP_FLG == SP_FLG_CODE){
				if($this->_data['title_image_sp']) $this->_data['title_image'] = $this->_data['title_image_sp'];
				if($this->_data['image_sp']) $this->_data['image'] = $this->_data['image_sp'];

				if(is_numeric($this->_data['bg_color_sp'])) $this->_data['bg_color'] = $this->_data['bg_color_sp'];
				if(is_numeric($this->_data['btm_padding_sp'])) $this->_data['btm_padding'] = $this->_data['btm_padding_sp'];
			}

			//画像パス
			if(isset($this->_data['title_image']) && $this->_data['title_image']!=null) {
				$this->_data['title_image'] = BINGOTOPURL.UNITS_IMG_PATH.$this->_data['title_image'];
			}
			if(isset($this->_data['image']) && $this->_data['image']!=null) {
				$this->_data['image'] = BINGOTOPURL.UNITS_IMG_PATH.$this->_data['image'];
			}
		}
		//▲データ操作  ////////

		//管理画面かどうかの判定用
		if((isset($_REQUEST['sidx_code']) && isset($_REQUEST['mode'])) || isset($_REQUEST['unit_code']) || isset($_REQUEST['utype'])){
			$this->_view->assign('isAdmin', true);
			$this->_view->assign('AdminJS', dirname(__FILE__)."/js/page-edit.js");
		}

		//ユニット編集時かどうかの判定用
		if(isset($_POST["unit_code"]) || $_POST['mode']=='add'){
			$this->_view->assign('isEdited', true);
		}

		//プレビュー画面かどうかの判定用
		$this->_view->assign('isPrev', $this->_prev);

		$this -> _view -> assign("unit_dir",$this->_unit_dir);
		$this -> _view -> assign('pageu_code', $this->_pageu_code);
		$this -> _view -> assign('data', $this->_data);
		return $this->_data;
	}

	/*
	 * DBより保存データ取得
	 * 改変可能
	 */
	function getDetail() {
		$sql = "select * from ".$this->getTbl()." where pageu_code = ?";
		if(isset($this->_pageu_code)&&is_numeric($this->_pageu_code)) {
			$result = $this->db->prepare($sql,$this->_pageu_code);
			$rtn = $result->fetchRow(DB_FETCHMODE_ASSOC);
		}
		return $rtn;
	}


	function setDefault()
	{
		$this->_data = $this->getDetail();
		if(isset($this->_data['title_image']) && $this->_data['title_image']!=null) {
			$this->_view->assign('image1', BINGOTOPURL.UNITS_IMG_PATH.$this->_data['title_image']);
		}
		if(isset($this->_data['title_image_sp']) && $this->_data['title_image_sp']!=null) {
			$this->_view->assign('image1_sp', BINGOTOPURL.UNITS_IMG_PATH.$this->_data['title_image_sp']);
		}
		if(isset($this->_data['image']) && $this->_data['image']!=null) {
			$this->_view->assign('image2', BINGOTOPURL.UNITS_IMG_PATH.$this->_data['image']);
		}
		if(isset($this->_data['image_sp']) && $this->_data['image_sp']!=null) {
			$this->_view->assign('image2_sp', BINGOTOPURL.UNITS_IMG_PATH.$this->_data['image_sp']);
		}
		if(!$this->_data){
			$this->_data['link_text'] = _gettext('B_T00624');
		}
		$this->_form->setDefaults($this->_data);
	}

	//フォームエレメントの作成
	function setElements()
	{
		$this->_form->addElement('hidden','pageu_code', $this->_pageu_code,array("id"=>"pageu_code")); //ページコード

		$this->_form->addElement('hidden', 'title_image', null, array('id'=>'title_image'));
		$this->_form->addElement('hidden', 'title_image_sp', null, array('id'=>'title_image_sp'));
		$this->_form->addElement('text', 'title_image_alt', null, array('id'=>'title_image_alt'));
		$this->_form->addElement('hidden', 'image', null, array('id'=>'image'));
		$this->_form->addElement('hidden', 'image_sp', null, array('id'=>'image_sp'));
		$this->_form->addElement('text', 'image_alt', null, array('id'=>'image_alt'));
		$this->_form->addElement('text', 'image_cap', null, array('id'=>'image_cap'));

		$this->_form->addElement('file', 'picture1', '');//画像アップ用ボタン
		$this->_form->addElement('file', 'picture2', '');//画像アップ用ボタン

		$this->_form->addElement('text', 'title', null, array('id'=>'title'));
		$this->_form->addElement('textarea', 'note', null, array('id'=>'note', 'rows'=>5));

		$this->_form->addElement('text', 'link_text', null, array('id'=>'link_text'));
		$this->_form->addElement('select', 'link_target', null, array(0=>'新しいウィンドウ', 1=>'同じウィンドウ'), array('id'=>'link_target'));

		$this->_form->addElement('text', 'link_url', null, array('id'=>'link_url'));

		$this -> _view -> assign("unit_dir",$this->_unit_dir);

		//表示中の画像サイズ
		$imgs_str = isset($_REQUEST["imgs"]) ? $_REQUEST["imgs"] : null;
		$this->_form->addElement('hidden','imgs', $imgs_str, array("id"=>"imgs"));

		$imgs_ar = array();
		if(!is_null($imgs_str)){
			$a = explode(":", $imgs_str);
			foreach((array)$a as $k=>$v){
				$imgs_ar[] = explode(",", $v);
			}
		}
		$this->_view->assign("imgs_ar", $imgs_ar);

		$data = $this->getDetail();
		if(empty($data) || LICENSE::getMode()==1){
				$this->_form->addElement("hidden", "autoregister1", 1);
				$this->_form->addElement("hidden", "autoregister2", 1);
		}else{
			$this->_form->setDefaults(array("autoregister1"=>1, "autoregister2"=>1));
			$this->_form->addElement("advcheckbox", "autoregister1", null, _gettext("B_P00940"), array(), array(0,1));
			$this->_form->addElement("advcheckbox", "autoregister2", null, _gettext("B_P00940"), array(), array(0,1));
		}
	}

	//フォーム入力エラーチェックの設定
	function setRules()
	{
		$this->_form->applyFilter('__ALL__','trim');
		$this->_form->_submitValues = DataBase::ConvColumnVals($this->_form->_submitValues,$this->columns); //ルールに従った値変換、タグの除去
		$this->_form->setJsWarnings('下記の項目が不正です。','');
		$this->_form->addRule('pageu_code','・「ユニットコード」が不明です。コンテンツ管理よりやり直してください','required',null,$this->erchk);

		$obj = $this->_form->getElement("title_image");
		if (!$obj->getValue()) {
			$this->_form->addRule('picture1',"・「画像タイトル」を入力してください。",'uploadedfile',null,'server');
		}
		$this->_form->addRule('picture1',_gettext('B_P00731',MAX_FILE_SIZE/(1000*1000)),'maxfilesize',MAX_FILE_SIZE,null,'server');
		$this->_form->addRule('picture1',_gettext('B_P00732'),'mimetype',array("image/pjpeg","image/jpeg","image/gif","image/x-png","image/png"));

		$obj = $this->_form->getElement("image");
		if (!$obj->getValue()) {
			$this->_form->addRule('picture2',"・「画像」を入力してください。",'uploadedfile',null,'server');
		}
		$this->_form->addRule('picture2',_gettext('B_P00734',MAX_FILE_SIZE/(1000*1000)),'maxfilesize',MAX_FILE_SIZE,null,'server');
		$this->_form->addRule('picture2',_gettext('B_P00735'),'mimetype',array("image/pjpeg","image/jpeg","image/gif","image/x-png","image/png"));

		$this->_form->addRule('note', '・「テキスト」を入力してください。', 'required', null, $this->erchk);

	}

	//データ下書き保存処理
	function doSave($post)
	{
		if(!is_numeric($post['pageu_code'])){
			return "・データの保存に失敗しました";
		}

		$record = null;
		foreach($this->columns as $val) {
			if($post[$val["column"]]!=null){
				$record[$val["column"]] = $post[$val["column"]];
			}else{
				$record[$val["column"]] = null;
			}
		}

		$imgmngrDB = new imgmngrDB();
		if(is_numeric($record["title_image"])) {
			$tmp_img_sp1 = $record["title_image"];
			// ここでhidden属性（上記の数値に設定されたもの）を現在設定されている画像パスの状態にもどす
			// 前提：エラー時（画像以外の入力でエラーになった場合でも）は新しく選択したファイルが画面上から消えること（既存ファイルが選択されている状態に戻る）
			if(is_array($old_data)&& count($old_data)>0){
				$this->_form->updateElementAttr('title_image',array('value' => $old_data['title_image']));
			}
			$imgdata = $imgmngrDB->getImageFromCode($record["title_image"], UNITS_IMG_PATH, $record["pageu_code"], 1);
			if(isset($imgdata)){
				$data_path1 = $imgdata["img_src"]; // コピー元（素材管理の画像パス）
				$img_path1 = $imgdata["gimg_src"];	// コピー先（公開用の画像パス）
				$record["title_image"] = array_pop(explode('/',$img_path1)); //保存ファイル名取得
				$cpflg1 = true;
			}else{
				$errstr = _gettext('B_P00715');
			}
		}
		if(empty($record["title_image_sp"]) || $_REQUEST["autoregister1"] == 1) {
			if(is_numeric($tmp_img_sp1)){
				$record["title_image_sp"] = $tmp_img_sp1;
				// ここでhidden属性（上記の数値に設定されたもの）を現在設定されている画像パスの状態にもどす
				// 前提：エラー時（画像以外の入力でエラーになった場合でも）は新しく選択したファイルが画面上から消えること（既存ファイルが選択されている状態に戻る）
				if(is_array($old_data)&& count($old_data)>0){
					$this->_form->updateElementAttr('title_image_sp',array('value' => $old_data['title_image_sp']));
				}
				$imgmngrDB = new imgmngrDB();
				$imgdata = $imgmngrDB->getImageFromCode($record["title_image_sp"], UNITS_IMG_PATH, $record["pageu_code"], 1);
				if(isset($imgdata)){
					$data_path1_sp = $imgdata["img_src"]; // コピー元（素材管理の画像パス）
					$img_path1_sp = $imgdata["gimg_src"];	// コピー先（公開用の画像パス）
					$record["title_image_sp"] = array_pop(explode('/',$img_path1_sp)); //保存ファイル名取得
					$cpflg1_sp = true;
				}else{
					$errstr = _gettext('B_P00701');
				}
			}else{
				$record["title_image_sp"] = $record["title_image"];
			}
		}else if(is_numeric($record["title_image_sp"])) {
			// ここでhidden属性（上記の数値に設定されたもの）を現在設定されている画像パスの状態にもどす
			// 前提：エラー時（画像以外の入力でエラーになった場合でも）は新しく選択したファイルが画面上から消えること（既存ファイルが選択されている状態に戻る）
			if(is_array($old_data)&& count($old_data)>0){
				$this->_form->updateElementAttr('title_image_sp',array('value' => $old_data['title_image_sp']));
			}
			$imgmngrDB = new imgmngrDB();
			$imgdata = $imgmngrDB->getImageFromCode($record["title_image_sp"], UNITS_IMG_PATH, $record["pageu_code"], 1);
			if(isset($imgdata)){
				$data_path1_sp = $imgdata["img_src"]; // コピー元（素材管理の画像パス）
				$img_path1_sp = $imgdata["gimg_src"];	// コピー先（公開用の画像パス）
				$record["title_image_sp"] = array_pop(explode('/',$img_path1_sp)); //保存ファイル名取得
				$cpflg1_sp = true;
			}else{
				$errstr = _gettext('B_P00701');
			}
		}

		if($post['delpic1'] == 1){
			$record["title_image"] = null;
		}
		if($post['delpic1_sp'] == 1){
			$record["title_image_sp"] = null;
		}

		if(is_numeric($record["image"])) {
			$tmp_img_sp2 = $record["image"];
			// ここでhidden属性（上記の数値に設定されたもの）を現在設定されている画像パスの状態にもどす
			// 前提：エラー時（画像以外の入力でエラーになった場合でも）は新しく選択したファイルが画面上から消えること（既存ファイルが選択されている状態に戻る）
			if(is_array($old_data)&& count($old_data)>0){
				$this->_form->updateElementAttr('image',array('value' => $old_data['image']));
			}
			$imgdata = $imgmngrDB->getImageFromCode($record["image"], UNITS_IMG_PATH, $record["pageu_code"], 1);
			if(isset($imgdata)){
				$data_path2 = $imgdata["img_src"]; // コピー元（素材管理の画像パス）
				$img_path2 = $imgdata["gimg_src"];	// コピー先（公開用の画像パス）
				$record["image"] = array_pop(explode('/',$img_path2)); //保存ファイル名取得
				$cpflg2 = true;
			}else{
				$errstr = _gettext('B_P00715');
			}
		}
		if(empty($record["image_sp"]) || $_REQUEST["autoregister2"] == 1) {
			if(is_numeric($tmp_img_sp2)){
				$record["image_sp"] = $tmp_img_sp2;
				// ここでhidden属性（上記の数値に設定されたもの）を現在設定されている画像パスの状態にもどす
				// 前提：エラー時（画像以外の入力でエラーになった場合でも）は新しく選択したファイルが画面上から消えること（既存ファイルが選択されている状態に戻る）
				if(is_array($old_data)&& count($old_data)>0){
					$this->_form->updateElementAttr('image_sp',array('value' => $old_data['image_sp']));
				}
				$imgmngrDB = new imgmngrDB();
				$imgdata = $imgmngrDB->getImageFromCode($record["image_sp"], UNITS_IMG_PATH, $record["pageu_code"], 1);
				if(isset($imgdata)){
					$data_path2_sp = $imgdata["img_src"]; // コピー元（素材管理の画像パス）
					$img_path2_sp = $imgdata["gimg_src"];	// コピー先（公開用の画像パス）
					$record["image_sp"] = array_pop(explode('/',$img_path2_sp)); //保存ファイル名取得
					$cpflg2_sp = true;
				}else{
					$errstr = _gettext('B_P00701');
				}
			}else{
				$record["image_sp"] = $record["image"];
			}
		}else if(is_numeric($record["image_sp"])) {
			// ここでhidden属性（上記の数値に設定されたもの）を現在設定されている画像パスの状態にもどす
			// 前提：エラー時（画像以外の入力でエラーになった場合でも）は新しく選択したファイルが画面上から消えること（既存ファイルが選択されている状態に戻る）
			if(is_array($old_data)&& count($old_data)>0){
				$this->_form->updateElementAttr('image_sp',array('value' => $old_data['image_sp']));
			}
			$imgmngrDB = new imgmngrDB();
			$imgdata = $imgmngrDB->getImageFromCode($record["image_sp"], UNITS_IMG_PATH, $record["pageu_code"], 1);
			if(isset($imgdata)){
				$data_path2_sp = $imgdata["img_src"]; // コピー元（素材管理の画像パス）
				$img_path2_sp = $imgdata["gimg_src"];	// コピー先（公開用の画像パス）
				$record["image_sp"] = array_pop(explode('/',$img_path2_sp)); //保存ファイル名取得
				$cpflg2_sp = true;
			}else{
				$errstr = _gettext('B_P00701');
			}
		}

		if($post['delpic2'] == 1){
			$record["image"] = null;
		}
		if($post['delpic2_sp'] == 1){
			$record["image_sp"] = null;
		}

		//既存データがあるか確認
		$old_data = $this->getDetail();
		$this->db->query('BEGIN');
		//保存処理開始
		if(is_array($old_data)&& count($old_data)>0) {
			//更新
			if(!$this->db->update($this->getTbl(),$record, "pageu_code=".$record["pageu_code"])) {
				$this->db->query('ROLLBACK');
				return "・データの保存に失敗しました";
			}
		} else { //新規
			if(!$this->db->insert($this->getTbl(),$record)) {
				$this->db->query('ROLLBACK');
				return "・データの保存に失敗しました";
			}
		}

		// ここでファイルのコピーを行う
		if($cpflg1) {
			if(!@copy(BASE_PATH.$data_path1, BASE_PATH.$img_path1)){
				$this->db->query('ROLLBACK');
				return _gettext('B_P00650');
			} else {
				@chmod(BASE_PATH.$img_path1, 0666);
			}
		}
		if($cpflg2) {
			if(!@copy(BASE_PATH.$data_path2, BASE_PATH.$img_path2)){
				$this->db->query('ROLLBACK');
				return _gettext('B_P00650');
			} else {
				@chmod(BASE_PATH.$img_path2, 0666);
			}
		}
		if($cpflg1_sp) {
			if(!@copy(BASE_PATH.$data_path1_sp, BASE_PATH.$img_path1_sp)){
				$this->db->query('ROLLBACK');
				return _gettext('B_P00650');
			} else {
				@chmod(BASE_PATH.$img_path1_sp, 0666);
			}
		}
		if($cpflg2_sp) {
			if(!@copy(BASE_PATH.$data_path2_sp, BASE_PATH.$img_path2_sp)){
				$this->db->query('ROLLBACK');
				return _gettext('B_P00650');
			} else {
				@chmod(BASE_PATH.$img_path2_sp, 0666);
			}
		}
		$this->db->query('COMMIT');
		return null;
	}


	//公開処理
	function TmptoCommon($pageu_code, $db) {
		return parent::TmptoCommon($pageu_code, $db);
	}

	/*
	 * ユニット複製処理（共通）
	 * page-unitlayout.phpより呼ばれます
	 * トランザクション処理は呼び元で行います
	 * @param $pageu_code コピー元のコード
	 * @param $target_pageu_code コピー先のコード
	 */
	function unitCopy($pageu_code, $target_pageu_code, $db, $itemcopy=false) {
		return parent::unitCopy($pageu_code, $target_pageu_code, $db, $itemcopy);
	}
}
?>